<template>
  <div class="block-content">
    <form>
      <div class="form-content">
        <label class="form-label">User name</label>
        <input id="username" type="text" class="form-value" v-model="user.userName"/>
      </div>
      <div class="err" id="username-err">
        <p style="color: red;">userName must not be empty</p>
      </div>
      <div class="form-content">
        <label class="form-label">Password</label>
        <input id="pass" type="text" class="form-value" v-model="user.password"/>
      </div>
      <div class="err" id="pass-err">
        <p style="color: red;">Password should have more than 8 characters</p>
      </div>
      <div class="form-content">
        <label class="form-label">Auth</label>
        <input id="auth" type="text" class="form-value" v-model="user.auth"/>
      </div>
      <div class="err" id="auth-err">
        <p style="color: red;">Auth should be "admin" or "user"</p>
      </div>
      <div class="form-content">
        <label class="form-label">Recipient</label>
        <select id="recip" class="form-value" v-model="user.recipientId">
          <option value="0" selected>---------</option>
          <option v-for="recipient in recipients" :key="recipient.id" :item="recipient"
          :value="recipient.id" v-on:click="user.recipentId = recipient.id">
            {{recipient.phone}}, {{recipient.email}}, {{recipient.street}}
          </option>
        </select>
      </div>
      <div class="err" id="recip-err">
        <p style="color: red;">Please relect one!</p>
      </div>
      <div class="form-content">
        <input type="button" value="Submit and new" class="form-button"
        v-on:click="submit('User')" />
        <input type="button" value="Submit" class="form-button"
        id="righter" v-on:click="submit('Users')" />
      </div>
    </form>
  </div>
</template>

<script>
import axios from 'axios';
import md5 from 'md5';

export default {
  name: 'User',
  props: {
    object: Number,
  },
  data() {
    return {
      user: {},
      recipients: [],
    };
  },
  mounted() {
    this.getRecipient();
    this.get();
  },
  methods: {
    getRecipient() {
      axios.get('http://localhost:4000/api/recipients').then(
        (result) => {
          this.recipients = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    get() {
      if (this.object > 0) {
        axios.get(`http://localhost:4000/api/users/${this.object}`).then(
          (result) => {
            this.user = result.data;
          },
        ).catch((error) => {
          console.log(error);
        });
      }
    },
    validateUser(obj) {
      const reg = ['admin', 'user'];
      if (obj.userName && obj.password
        && obj.auth && obj.recipientId
        && reg.includes(obj.auth)
        && obj.password.length >= 8) {
        return true;
      }
      if (!obj.userName) {
        document.getElementById('username').style.borderColor = 'red';
        document.getElementById('username-err').style.display = 'block';
      }
      if (!obj.password || obj.password.length < 8) {
        document.getElementById('pass').style.borderColor = 'red';
        document.getElementById('pass-err').style.display = 'block';
      }
      if (!obj.auth || !reg.includes(obj.auth)) {
        document.getElementById('auth').style.borderColor = 'red';
        document.getElementById('auth-err').style.display = 'block';
      }
      if (!obj.recipientId) {
        document.getElementById('recip').style.borderColor = 'red';
        document.getElementById('recip-err').style.display = 'block';
      }

      return false;
    },
    submit(component) {
      if (this.object === 0) {
        if (this.validateUser(this.user)) {
          axios.post('http://localhost:4000/api/users', {
            userName: this.user.userName,
            password: md5(this.user.password),
            auth: this.user.auth,
            recipientId: this.user.recipientId,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
          axios.post('http://localhost:4000/send-email', {
            to: this.user.userName,
            subject: 'New password for aplication TrackingId',
            message: `Your username: ${this.user.userName}
              \n Your password: ${this.user.password}`,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
          this.nullify();
          this.$emit('change-component', component);
        }
      } else if (this.validateUser(this.user)) {
        axios.patch(`http://localhost:4000/api/users/${this.object}`, {
          userName: this.user.userName,
          password: this.password(),
          auth: this.user.auth,
          recipientId: this.user.recipientId,
        })
          .then((response) => { console.log(response); alert('succesfully saved!'); })
          .catch((e) => {
            console.log(e);
          });
        this.$emit('change-component', component);
        this.$emit('object', 0);
      }
    },
    password() {
      return ((this.user.password.length === 32) ? this.user.password : md5(this.user.password));
    },
    nullify() {
      document.getElementById('username').value = '';
      document.getElementById('pass').value = '';
      document.getElementById('auth').value = '';
    },
  },
};
</script>

<style scoped>
@import "../CSS/actionObject.css";
</style>
